Index: code/branches/output/src/modules/questsystem/GlobalQuest.cc
===================================================================
--- code/branches/output/src/modules/questsystem/GlobalQuest.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/GlobalQuest.cc	(revision 8811)
@@ -71,5 +71,5 @@
         XMLPortObject(GlobalQuest, QuestEffect, "reward-effects", addRewardEffect, getRewardEffects, xmlelement, mode);
 
-        COUT(4) << "New GlobalQuest {" << this->getId() << "} created." << std::endl;
+        orxout(verbose, context::quests) << "New GlobalQuest {" << this->getId() << "} created." << endl;
     }
 
@@ -87,5 +87,5 @@
         if(!this->isFailable(player)) // Check whether the Quest can be failed.
         {
-            COUT(4) << "A non-completable quest was trying to be failed." << std::endl;
+            orxout(verbose, context::quests) << "A non-completable quest was trying to be failed." << endl;
             return false;
         }
@@ -114,5 +114,5 @@
         if(!this->isCompletable(player)) // Check whether the Quest can be completed.
         {
-            COUT(4) << "A non-completable quest was trying to be completed." << std::endl;
+            orxout(verbose, context::quests) << "A non-completable quest was trying to be completed." << endl;
             return false;
         }
@@ -227,5 +227,5 @@
         this->rewards_.push_back(effect); // Add the QuestEffect to the list.
 
-        COUT(4) << "Reward effect was added to Quest {" << this->getId() << "}." << std::endl;
+        orxout(verbose, context::quests) << "Reward effect was added to Quest {" << this->getId() << "}." << endl;
         return true;
     }
Index: code/branches/output/src/modules/questsystem/LocalQuest.cc
===================================================================
--- code/branches/output/src/modules/questsystem/LocalQuest.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/LocalQuest.cc	(revision 8811)
@@ -69,5 +69,5 @@
         SUPER(LocalQuest, XMLPort, xmlelement, mode);
 
-        COUT(4) << "New LocalQuest {" << this->getId() << "} created." << std::endl;
+        orxout(verbose, context::quests) << "New LocalQuest {" << this->getId() << "} created." << endl;
     }
 
@@ -85,5 +85,5 @@
         if(!this->isFailable(player)) // Checks whether the quest can be failed.
         {
-            COUT(4) << "A non-failable quest was trying to be failed." << std::endl;
+            orxout(verbose, context::quests) << "A non-failable quest was trying to be failed." << endl;
             return false;
         }
@@ -108,5 +108,5 @@
         if(!this->isCompletable(player)) // Checks whether the Quest can be completed.
         {
-            COUT(4) << "A non-completable quest was trying to be completed." << std::endl;
+            orxout(verbose, context::quests) << "A non-completable quest was trying to be completed." << endl;
             return false;
         }
Index: code/branches/output/src/modules/questsystem/Quest.cc
===================================================================
--- code/branches/output/src/modules/questsystem/Quest.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/Quest.cc	(revision 8811)
@@ -96,5 +96,5 @@
         this->parentQuest_ = quest;
 
-        COUT(4) << "Parent Quest {" << quest->getId() << "} was added to Quest {" << this->getId() << "}." << std::endl;
+        orxout(verbose, context::quests) << "Parent Quest {" << quest->getId() << "} was added to Quest {" << this->getId() << "}." << endl;
         return true;
     }
@@ -115,5 +115,5 @@
         this->subQuests_.push_back(quest); // Adds the Quest to the end of the list of sub-quests.
 
-        COUT(4) << "Sub Quest {" << quest->getId() << "} was added to Quest {" << this->getId() << "}." << std::endl;
+        orxout(verbose, context::quests) << "Sub Quest {" << quest->getId() << "} was added to Quest {" << this->getId() << "}." << endl;
         return true;
     }
@@ -135,5 +135,5 @@
         this->hints_.push_back(hint); // Adds the QuestHint to the end of the list of QuestHints.
 
-        COUT(4) << "QuestHint {" << hint->getId() << "} was added to Quest {" << this->getId() << "}." << std::endl;
+        orxout(verbose, context::quests) << "QuestHint {" << hint->getId() << "} was added to Quest {" << this->getId() << "}." << endl;
         return true;
     }
@@ -153,5 +153,5 @@
         this->failEffects_.push_back(effect); // Adds the QuestEffect to the end of the list of fail QuestEffects.
 
-        COUT(4) << "A FailEffect was added to Quest {" << this->getId() << "}." << std::endl;
+        orxout(verbose, context::quests) << "A FailEffect was added to Quest {" << this->getId() << "}." << endl;
         return true;
     }
@@ -171,5 +171,5 @@
         this->completeEffects_.push_back(effect); // Adds the QuestEffect to the end of the list of complete QuestEffects.
 
-        COUT(4) << "A CompleteEffect was added to Quest {" << this->getId() << "}." << std::endl;
+        orxout(verbose, context::quests) << "A CompleteEffect was added to Quest {" << this->getId() << "}." << endl;
         return true;
     }
@@ -341,5 +341,5 @@
         this->setStatus(player, QuestStatus::Failed);
 
-        COUT(4) << "Quest {" << this->getId() << "} is failed for player: " << player << " ." <<std::endl;
+        orxout(verbose, context::quests) << "Quest {" << this->getId() << "} is failed for player: " << player << " ." << endl;
 
         this->getDescription()->sendFailQuestNotification(player);
@@ -360,5 +360,5 @@
         this->setStatus(player, QuestStatus::Completed);
 
-        COUT(4) << "Quest {" << this->getId() << "} is completed for player: " << player << " ." <<std::endl;
+        orxout(verbose, context::quests) << "Quest {" << this->getId() << "} is completed for player: " << player << " ." << endl;
 
         this->getDescription()->sendCompleteQuestNotification(player);
@@ -378,9 +378,9 @@
         if(!this->isStartable(player)) // Checks whether the quest can be started.
         {
-            COUT(4) << "A non-startable quest was trying to be started." << std::endl;
+            orxout(verbose, context::quests) << "A non-startable quest was trying to be started." << endl;
             return false;
         }
 
-        COUT(4) << "Quest {" << this->getId() << "} is started for player: " << player << " ." <<std::endl;
+        orxout(verbose, context::quests) << "Quest {" << this->getId() << "} is started for player: " << player << " ." << endl;
 
         QuestListener::advertiseStatusChange(this->listeners_, "start"); // Tells the QuestListeners, that the status has changed to active.
Index: code/branches/output/src/modules/questsystem/QuestDescription.cc
===================================================================
--- code/branches/output/src/modules/questsystem/QuestDescription.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/QuestDescription.cc	(revision 8811)
@@ -79,5 +79,5 @@
         XMLPortParam(QuestDescription, "completeMessage", setCompleteMessage, getCompleteMessage, xmlelement, mode);
 
-        COUT(4) << "New QuestDescription with title '" << this->getTitle() << "' created." << std::endl;
+        orxout(verbose, context::quests) << "New QuestDescription with title '" << this->getTitle() << "' created." << endl;
     }
 
@@ -109,5 +109,5 @@
             else
             {
-                COUT(2) << "Bad input in notificationHelper, this should not be happening!" << std::endl;
+                orxout(internal_warning, context::quests) << "Bad input in notificationHelper, this should not be happening!" << endl;
                 return false;
             }
@@ -115,5 +115,5 @@
         else
         {
-            COUT(2) << "Bad input in notificationHelper, this should not be happening!" << std::endl;
+            orxout(internal_warning, context::quests) << "Bad input in notificationHelper, this should not be happening!" << endl;
             return false;
         }
Index: code/branches/output/src/modules/questsystem/QuestEffect.cc
===================================================================
--- code/branches/output/src/modules/questsystem/QuestEffect.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/QuestEffect.cc	(revision 8811)
@@ -70,5 +70,5 @@
         bool temp = true;
 
-        COUT(4) << "Invoking QuestEffects on player: " << player << " ."  << std::endl;
+        orxout(verbose, context::quests) << "Invoking QuestEffects on player: " << player << " ."  << endl;
 
         for (std::list<QuestEffect*>::iterator effect = effects.begin(); effect != effects.end(); effect++)
Index: code/branches/output/src/modules/questsystem/QuestEffectBeacon.cc
===================================================================
--- code/branches/output/src/modules/questsystem/QuestEffectBeacon.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/QuestEffectBeacon.cc	(revision 8811)
@@ -79,5 +79,5 @@
         XMLPortEventSink(QuestEffectBeacon, BaseObject, "execute", execute, xmlelement, mode); //TODO: Change BaseObject to MultiTrigger as soon as MultiTrigger is the base of all triggers.
 
-        COUT(4) << "New QuestEffectBeacon created." << std::endl;
+        orxout(verbose, context::quests) << "New QuestEffectBeacon created." << endl;
     }
 
@@ -108,5 +108,5 @@
         if(!(this->isActive())) // If the QuestEffectBeacon is inactive it cannot be executed.
         {
-            COUT(4) << "The QuestEffectBeacon is inactive." << std::endl;
+            orxout(verbose, context::quests) << "The QuestEffectBeacon is inactive." << endl;
             return false;
         }
@@ -128,9 +128,9 @@
         if(player == NULL)
         {
-            COUT(4) << "The QuestEffectBeacon was triggered by an entity other than a Pawn. (" << trigger->getIdentifier()->getName() << ")" << std::endl;
-            return false;
-        }
-
-        COUT(4) << "QuestEffectBeacon executed on player: " << player << " ." << std::endl;
+            orxout(verbose, context::quests) << "The QuestEffectBeacon was triggered by an entity other than a Pawn. (" << trigger->getIdentifier()->getName() << ")" << endl;
+            return false;
+        }
+
+        orxout(verbose, context::quests) << "QuestEffectBeacon executed on player: " << player << " ." << endl;
 
         bool temp = QuestEffect::invokeEffects(player, this->effects_); // Invoke the QuestEffects on the PlayerInfo.
@@ -221,5 +221,5 @@
         this->effects_.push_back(effect);
 
-        COUT(4) << "A QuestEffect was added to a QuestEffectBeacon." << std::endl;
+        orxout(verbose, context::quests) << "A QuestEffect was added to a QuestEffectBeacon." << endl;
         return true;
     }
Index: code/branches/output/src/modules/questsystem/QuestHint.cc
===================================================================
--- code/branches/output/src/modules/questsystem/QuestHint.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/QuestHint.cc	(revision 8811)
@@ -74,5 +74,5 @@
         QuestManager::getInstance().registerHint(this); // Registers the QuestHint with the QuestManager.
 
-        COUT(4) << "New QuestHint {" << this->getId() << "} created." << std::endl;
+        orxout(verbose, context::quests) << "New QuestHint {" << this->getId() << "} created." << endl;
     }
 
@@ -120,10 +120,10 @@
             else
             {
-                COUT(4) << "An already active questHint was trying to get activated." << std::endl;
+                orxout(verbose, context::quests) << "An already active questHint was trying to get activated." << endl;
                 return false;
             }
         }
 
-        COUT(4) << "A hint of a non-active quest was trying to get activated." << std::endl;
+        orxout(verbose, context::quests) << "A hint of a non-active quest was trying to get activated." << endl;
         return false;
     }
Index: code/branches/output/src/modules/questsystem/QuestItem.cc
===================================================================
--- code/branches/output/src/modules/questsystem/QuestItem.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/QuestItem.cc	(revision 8811)
@@ -89,5 +89,5 @@
         if(id == "") // Checks whether the id is a valid id.
         {
-            COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
+            orxout(internal_warning, context::quests) << "Invalid id. QuestItem id {" << id << "} could not be set." << endl;
             return;
         }
Index: code/branches/output/src/modules/questsystem/QuestListener.cc
===================================================================
--- code/branches/output/src/modules/questsystem/QuestListener.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/QuestListener.cc	(revision 8811)
@@ -84,5 +84,5 @@
             this->quest_->addListener(this); // Adds the QuestListener to the Quests list of listeners.
 
-        COUT(4) << "QuestListener created for quest: {" << this->quest_->getId() << "} with mode '" << this->getMode() << "'." << std::endl;
+        orxout(verbose, context::quests) << "QuestListener created for quest: {" << this->quest_->getId() << "} with mode '" << this->getMode() << "'." << endl;
     }
 
@@ -146,5 +146,5 @@
         else
         {
-            COUT(2) << "QuestListener with invalid mode '" << mode << "' created. Mode set to 'all'." << std::endl;
+            orxout(internal_warning, context::quests) << "QuestListener with invalid mode '" << mode << "' created. Mode set to 'all'." << endl;
             this->mode_ = QuestListenerMode::All;
             return false;
Index: code/branches/output/src/modules/questsystem/QuestManager.cc
===================================================================
--- code/branches/output/src/modules/questsystem/QuestManager.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/QuestManager.cc	(revision 8811)
@@ -61,5 +61,5 @@
         RegisterRootObject(QuestManager);
 
-        COUT(3) << "QuestManager created." << std::endl;
+        orxout(internal_info, context::quests) << "QuestManager created." << endl;
     }
 
@@ -70,5 +70,5 @@
     QuestManager::~QuestManager()
     {
-        COUT(3) << "QuestManager destroyed." << std::endl;
+        orxout(internal_info, context::quests) << "QuestManager destroyed." << endl;
     }
 
@@ -103,10 +103,10 @@
         {
             quest->setRegistered();
-            COUT(4) << "Quest with questId {" << quest->getId() << "} successfully inserted." << std::endl;
+            orxout(verbose, context::quests) << "Quest with questId {" << quest->getId() << "} successfully inserted." << endl;
             return true;
         }
         else
         {
-           COUT(2) << "Quest with the same id was already present." << std::endl;
+           orxout(internal_warning, context::quests) << "Quest with the same id was already present." << endl;
            return false;
         }
@@ -141,10 +141,10 @@
         {
             hint->setRegistered();
-            COUT(4) << "QuestHint with hintId {" << hint->getId() << "} successfully inserted." << std::endl;
+            orxout(verbose, context::quests) << "QuestHint with hintId {" << hint->getId() << "} successfully inserted." << endl;
             return true;
         }
         else
         {
-           COUT(2) << "QuestHint with the same id was already present." << std::endl;
+           orxout(internal_warning, context::quests) << "QuestHint with the same id was already present." << endl;
            return false;
         }
@@ -183,5 +183,5 @@
         {
            quest = NULL;
-           COUT(2) << "The quest with id {" << questId << "} is nowhere to be found." << std::endl;
+           orxout(internal_warning, context::quests) << "The quest with id {" << questId << "} is nowhere to be found." << endl;
         }
 
@@ -212,5 +212,5 @@
         {
            hint = NULL;
-           COUT(2) << "The hint with id {" << hintId << "} is nowhere to be found." << std::endl;
+           orxout(internal_warning, context::quests) << "The hint with id {" << hintId << "} is nowhere to be found." << endl;
         }
 
@@ -431,5 +431,5 @@
         if(player == NULL)
         {
-            COUT(1) << "Error: GUIOverlay with name '" << guiName << "' has no player." << std::endl;
+            orxout(internal_error, context::quests) << "GUIOverlay with name '" << guiName << "' has no player." << endl;
             return NULL;
         }
Index: code/branches/output/src/modules/questsystem/effects/AddQuest.cc
===================================================================
--- code/branches/output/src/modules/questsystem/effects/AddQuest.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/effects/AddQuest.cc	(revision 8811)
@@ -70,5 +70,5 @@
         SUPER(AddQuest, XMLPort, xmlelement, mode);
 
-        COUT(4) << "New AddQuest, with target Quest {" << this->getQuestId() << "}, created." << std::endl;
+        orxout(verbose, context::quests) << "New AddQuest, with target Quest {" << this->getQuestId() << "}, created." << endl;
     }
 
@@ -85,5 +85,5 @@
         assert(player);
 
-        COUT(5) << "AddQuest on player: " << player << " ." << std::endl;
+        orxout(verbose_more, context::quests) << "AddQuest on player: " << player << " ." << endl;
 
         try
@@ -95,9 +95,9 @@
         catch(const orxonox::Exception& ex)
         {
-            COUT(2) << ex.getFullDescription() << std::endl;
+            orxout(internal_warning, context::quests) << ex.getFullDescription() << endl;
             return false;
         }
 
-        COUT(4) << "Quest {" << this->getQuestId() << "} successfully added to player: " << player << " ." << std::endl;
+        orxout(verbose, context::quests) << "Quest {" << this->getQuestId() << "} successfully added to player: " << player << " ." << endl;
         return true;
     }
Index: code/branches/output/src/modules/questsystem/effects/AddQuestHint.cc
===================================================================
--- code/branches/output/src/modules/questsystem/effects/AddQuestHint.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/effects/AddQuestHint.cc	(revision 8811)
@@ -73,5 +73,5 @@
         XMLPortParam(AddQuestHint, "hintId", setHintId, getHintId, xmlelement, mode);
 
-        COUT(4) << "New AddQuestHint, with target QuestHint {" << this->getHintId() << "}, created." << std::endl;
+        orxout(verbose, context::quests) << "New AddQuestHint, with target QuestHint {" << this->getHintId() << "}, created." << endl;
     }
 
@@ -88,5 +88,5 @@
         if(id == "")
         {
-            COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
+            orxout(internal_warning, context::quests) << "Invalid id. QuestItem id {" << id << "} could not be set." << endl;
             return false;
         }
@@ -108,5 +108,5 @@
         assert(player);
 
-        COUT(5) << "AddQuestHint on player: " << player << " ." << std::endl;
+        orxout(verbose_more, context::quests) << "AddQuestHint on player: " << player << " ." << endl;
 
         try
@@ -118,9 +118,9 @@
         catch(const Exception& e)
         {
-           COUT(2) << e.getFullDescription() << std::endl;
+           orxout(internal_warning, context::quests) << e.getFullDescription() << endl;
            return false;
         }
 
-        COUT(4) << "QuestHint {" << this->getHintId() << "} successfully added to player: " << player << " ." << std::endl;
+        orxout(verbose, context::quests) << "QuestHint {" << this->getHintId() << "} successfully added to player: " << player << " ." << endl;
         return true;
 
Index: code/branches/output/src/modules/questsystem/effects/AddReward.cc
===================================================================
--- code/branches/output/src/modules/questsystem/effects/AddReward.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/effects/AddReward.cc	(revision 8811)
@@ -70,5 +70,5 @@
         XMLPortObject(AddReward, Rewardable, "", addRewardable, getRewardables, xmlelement, mode);
 
-        COUT(4) << "New AddReward, with " << this->rewards_.size() << " Rewardables created." << std::endl;
+        orxout(verbose, context::quests) << "New AddReward, with " << this->rewards_.size() << " Rewardables created." << endl;
     }
 
@@ -103,5 +103,5 @@
     bool AddReward::invoke(PlayerInfo* player)
     {
-        COUT(5) << "AddReward on player: " << player << " ." << std::endl;
+        orxout(verbose_more, context::quests) << "AddReward on player: " << player << " ." << endl;
 
         bool temp = true;
@@ -109,5 +109,5 @@
             temp = temp && (*reward)->reward(player);
 
-        COUT(4) << "Rewardable successfully added to player." << player << " ." << std::endl;
+        orxout(verbose, context::quests) << "Rewardable successfully added to player." << player << " ." << endl;
 
         return temp;
Index: code/branches/output/src/modules/questsystem/effects/ChangeQuestStatus.cc
===================================================================
--- code/branches/output/src/modules/questsystem/effects/ChangeQuestStatus.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/effects/ChangeQuestStatus.cc	(revision 8811)
@@ -83,5 +83,5 @@
         if(id == "")
         {
-            COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
+            orxout(internal_warning, context::quests) << "Invalid id. QuestItem id {" << id << "} could not be set." << endl;
             return false;
         }
Index: code/branches/output/src/modules/questsystem/effects/CompleteQuest.cc
===================================================================
--- code/branches/output/src/modules/questsystem/effects/CompleteQuest.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/effects/CompleteQuest.cc	(revision 8811)
@@ -70,5 +70,5 @@
         SUPER(CompleteQuest, XMLPort, xmlelement, mode);
 
-        COUT(4) << "New CompleteQuest, with target Quest {" << this->getQuestId() << "}, created." << std::endl;
+        orxout(verbose, context::quests) << "New CompleteQuest, with target Quest {" << this->getQuestId() << "}, created." << endl;
     }
 
@@ -85,5 +85,5 @@
         assert(player);
 
-        COUT(5) << "CompleteQuest on player: " << player << " ." << std::endl;
+        orxout(verbose_more, context::quests) << "CompleteQuest on player: " << player << " ." << endl;
 
         Quest* quest;
@@ -97,9 +97,9 @@
         catch(const Exception& e)
         {
-            COUT(2) << e.getFullDescription() << std::endl;
+            orxout(internal_warning, context::quests) << e.getFullDescription() << endl;
             return false;
         }
 
-        COUT(4) << "Quest {" << quest->getId() << "} successfully completed by player: " << player << " ." << std::endl;
+        orxout(verbose, context::quests) << "Quest {" << quest->getId() << "} successfully completed by player: " << player << " ." << endl;
         return true;
     }
Index: code/branches/output/src/modules/questsystem/effects/FailQuest.cc
===================================================================
--- code/branches/output/src/modules/questsystem/effects/FailQuest.cc	(revision 8739)
+++ code/branches/output/src/modules/questsystem/effects/FailQuest.cc	(revision 8811)
@@ -70,5 +70,5 @@
         SUPER(FailQuest, XMLPort, xmlelement, mode);
 
-        COUT(4) << "New FailQuest, with target Quest {" << this->getQuestId() << "}, created." << std::endl;
+        orxout(verbose, context::quests) << "New FailQuest, with target Quest {" << this->getQuestId() << "}, created." << endl;
     }
 
@@ -85,5 +85,5 @@
         assert(player);
 
-        COUT(4) << "FailQuest on player: " << player << " ." << std::endl;
+        orxout(verbose, context::quests) << "FailQuest on player: " << player << " ." << endl;
 
         Quest* quest;
@@ -96,9 +96,9 @@
         catch(const Exception& e)
         {
-            COUT(2) << e.getFullDescription() << std::endl;
+            orxout(internal_warning, context::quests) << e.getFullDescription() << endl;
             return false;
         }
 
-        COUT(4) << "Quest {" << quest->getId() << "} failed by player: " << player << " ." << std::endl;
+        orxout(verbose, context::quests) << "Quest {" << quest->getId() << "} failed by player: " << player << " ." << endl;
         return true;
     }