Index: code/branches/output/data/levels/templates/FPS.oxt
===================================================================
--- code/branches/output/data/levels/templates/FPS.oxt	(revision 8819)
+++ code/branches/output/data/levels/templates/FPS.oxt	(revision 8820)
@@ -30,5 +30,5 @@
     
     <?lua
-	include("includes/weaponSettingsFPS.oxi")
+	include("../includes/weaponSettingsFPS.oxi")
     ?>
 
Index: code/branches/output/data/levels/templates/spaceshipAssff.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipAssff.oxt	(revision 8819)
+++ code/branches/output/data/levels/templates/spaceshipAssff.oxt	(revision 8820)
@@ -56,5 +56,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettingsAssff.oxi")
+  include("../includes/weaponSettingsAssff.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipAssff2.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipAssff2.oxt	(revision 8819)
+++ code/branches/output/data/levels/templates/spaceshipAssff2.oxt	(revision 8820)
@@ -56,5 +56,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettingsAssff2.oxi")
+  include("../includes/weaponSettingsAssff2.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipGhost.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipGhost.oxt	(revision 8819)
+++ code/branches/output/data/levels/templates/spaceshipGhost.oxt	(revision 8820)
@@ -36,5 +36,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettingsGhost.oxi")
+  include("../includes/weaponSettingsGhost.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipH2.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipH2.oxt	(revision 8819)
+++ code/branches/output/data/levels/templates/spaceshipH2.oxt	(revision 8820)
@@ -22,5 +22,5 @@
 
 <?lua
-  include("includes/weaponSettingsH2.oxi")
+  include("../includes/weaponSettingsH2.oxi")
 ?>
     <engines>
Index: code/branches/output/data/levels/templates/spaceshipHXY.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipHXY.oxt	(revision 8819)
+++ code/branches/output/data/levels/templates/spaceshipHXY.oxt	(revision 8820)
@@ -37,5 +37,5 @@
 
 <?lua
-  include("includes/weaponSettingsHXY.oxi")
+  include("../includes/weaponSettingsHXY.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipHXYSL.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipHXYSL.oxt	(revision 8819)
+++ code/branches/output/data/levels/templates/spaceshipHXYSL.oxt	(revision 8820)
@@ -36,5 +36,5 @@
 
 <?lua
-  include("includes/weaponSettingsHXY.oxi")
+  include("../includes/weaponSettingsHXY.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipImmTest.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipImmTest.oxt	(revision 8819)
+++ code/branches/output/data/levels/templates/spaceshipImmTest.oxt	(revision 8820)
@@ -37,5 +37,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettingsImmTest.oxi")
+  include("../includes/weaponSettingsImmTest.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipPirate.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipPirate.oxt	(revision 8819)
+++ code/branches/output/data/levels/templates/spaceshipPirate.oxt	(revision 8820)
@@ -40,5 +40,5 @@
 
 <?lua
-  include("includes/weaponSettingsPirate.oxi")
+  include("../includes/weaponSettingsPirate.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipSwallow.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipSwallow.oxt	(revision 8819)
+++ code/branches/output/data/levels/templates/spaceshipSwallow.oxt	(revision 8820)
@@ -35,5 +35,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettingsSwallow.oxi")
+  include("../includes/weaponSettingsSwallow.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipTransporter.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipTransporter.oxt	(revision 8819)
+++ code/branches/output/data/levels/templates/spaceshipTransporter.oxt	(revision 8820)
@@ -36,5 +36,5 @@
 
 <?lua
-  include("includes/weaponSettingsTransporter.oxi")
+  include("../includes/weaponSettingsTransporter.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/data/levels/templates/spaceshipTransporterSL.oxt
===================================================================
--- code/branches/output/data/levels/templates/spaceshipTransporterSL.oxt	(revision 8819)
+++ code/branches/output/data/levels/templates/spaceshipTransporterSL.oxt	(revision 8820)
@@ -36,5 +36,5 @@
 
 <?lua
-  include("includes/weaponSettingsTransporter.oxi")
+  include("../includes/weaponSettingsTransporter.oxi")
 ?>
   </SpaceShip>
Index: code/branches/output/src/libraries/core/GraphicsManager.cc
===================================================================
--- code/branches/output/src/libraries/core/GraphicsManager.cc	(revision 8819)
+++ code/branches/output/src/libraries/core/GraphicsManager.cc	(revision 8820)
@@ -114,5 +114,5 @@
         resources_.reset(new XMLFile("DefaultResources.oxr"));
         resources_->setLuaSupport(false);
-        Loader::open(resources_.get());
+        Loader::open(resources_.get(), ClassTreeMask(), false);
 
         // Only for runs in the build directory (not installed)
@@ -122,5 +122,5 @@
         extResources_.reset(new XMLFile("resources.oxr"));
         extResources_->setLuaSupport(false);
-        Loader::open(extResources_.get());
+        Loader::open(extResources_.get(), ClassTreeMask(), false);
 
         if (bLoadRenderer)
@@ -313,5 +313,5 @@
         orxout(internal_info) << "Loading Debug Overlay..." << endl;
         debugOverlay_.reset(new XMLFile("debug.oxo"));
-        Loader::open(debugOverlay_.get());
+        Loader::open(debugOverlay_.get(), ClassTreeMask(), false);
     }
 
Index: code/branches/output/src/libraries/core/Loader.cc
===================================================================
--- code/branches/output/src/libraries/core/Loader.cc	(revision 8819)
+++ code/branches/output/src/libraries/core/Loader.cc	(revision 8820)
@@ -49,8 +49,8 @@
     ClassTreeMask Loader::currentMask_s;
 
-    bool Loader::open(const XMLFile* file, const ClassTreeMask& mask)
+    bool Loader::open(const XMLFile* file, const ClassTreeMask& mask, bool bVerbose)
     {
         Loader::add(file, mask);
-        return Loader::load(file, mask);
+        return Loader::load(file, mask, bVerbose);
     }
 
Index: code/branches/output/src/libraries/core/Loader.h
===================================================================
--- code/branches/output/src/libraries/core/Loader.h	(revision 8819)
+++ code/branches/output/src/libraries/core/Loader.h	(revision 8820)
@@ -51,5 +51,5 @@
     {
         public:
-            static bool open(const XMLFile* file, const ClassTreeMask& mask = ClassTreeMask());
+            static bool open(const XMLFile* file, const ClassTreeMask& mask = ClassTreeMask(), bool bVerbose = true);
             static void close();
             static void close(const XMLFile* file);
Index: code/branches/output/src/orxonox/worldentities/WorldEntity.cc
===================================================================
--- code/branches/output/src/orxonox/worldentities/WorldEntity.cc	(revision 8819)
+++ code/branches/output/src/orxonox/worldentities/WorldEntity.cc	(revision 8820)
@@ -95,5 +95,5 @@
         this->collisionType_             = None;
         this->collisionTypeSynchronised_ = None;
-        this->mass_           = 0;
+        this->mass_           = 1.0f;
         this->childrenMass_   = 0;
         // Using bullet default values
@@ -968,5 +968,5 @@
                 this->physicalBody_->setMassProps(0.0f, btVector3(0, 0, 0));
             }
-            else if ((this->mass_ + this->childrenMass_) == 0.0f)
+            else if (totalMass == 0.0f)
             {
                 // Use default values to avoid very large or very small values