Index: code/branches/output/data/levels/presentationDM.oxw
===================================================================
--- code/branches/output/data/levels/presentationDM.oxw	(revision 8821)
+++ code/branches/output/data/levels/presentationDM.oxw	(revision 8822)
@@ -16,4 +16,5 @@
  name         = "Presentation"
  description  = "A simple testlevel"
+ gametype     = Deathmatch
 >
   <templates>
Index: code/branches/output/src/libraries/network/Host.cc
===================================================================
--- code/branches/output/src/libraries/network/Host.cc	(revision 8821)
+++ code/branches/output/src/libraries/network/Host.cc	(revision 8822)
@@ -91,46 +91,34 @@
   void Host::Chat(const std::string& message)
   {
-    if(instances_s.size()==0)
+    for (ObjectList<ChatListener>::iterator it = ObjectList<ChatListener>::begin(); it != ObjectList<ChatListener>::end(); ++it)
+      it->incomingChat(message, 0);
+
+    bool result = true;
+    for( std::vector<Host*>::iterator it = instances_s.begin(); it!=instances_s.end(); ++it )
     {
-      for (ObjectList<ChatListener>::iterator it = ObjectList<ChatListener>::begin(); it != ObjectList<ChatListener>::end(); ++it)
-        it->incomingChat(message, 0);
-//      return true;
+      if( (*it)->isActive() )
+      {
+        if( !(*it)->chat(message) )
+          result = false;
+      }
     }
-    else
-    {
-      bool result = true;
-      for( std::vector<Host*>::iterator it = instances_s.begin(); it!=instances_s.end(); ++it )
-      {
-        if( (*it)->isActive() )
-        {
-          if( !(*it)->chat(message) )
-            result = false;
-        }
-      }
-//      return result;
-    }
+//    return result;
   }
 
   bool Host::Broadcast(const std::string& message)
   {
-    if(instances_s.size()==0)
+    for (ObjectList<ChatListener>::iterator it = ObjectList<ChatListener>::begin(); it != ObjectList<ChatListener>::end(); ++it)
+      it->incomingChat(message, NETWORK_PEER_ID_BROADCAST);
+
+    bool result = true;
+    for( std::vector<Host*>::iterator it = instances_s.begin(); it!=instances_s.end(); ++it )
     {
-      for (ObjectList<ChatListener>::iterator it = ObjectList<ChatListener>::begin(); it != ObjectList<ChatListener>::end(); ++it)
-        it->incomingChat(message, NETWORK_PEER_ID_BROADCAST);
-      return true;
+      if( (*it)->isActive() )
+      {
+        if( !(*it)->broadcast(message) )
+          result = false;
+      }
     }
-    else
-    {
-      bool result = true;
-      for( std::vector<Host*>::iterator it = instances_s.begin(); it!=instances_s.end(); ++it )
-      {
-        if( (*it)->isActive() )
-        {
-          if( !(*it)->broadcast(message) )
-            result = false;
-        }
-      }
-      return result;
-    }
+    return result;
   }
 
@@ -161,5 +149,5 @@
     return false;
   }
-  
+
   Host* Host::getActiveInstance()
   {
Index: code/branches/output/src/modules/gametypes/RaceCheckPoint.cc
===================================================================
--- code/branches/output/src/modules/gametypes/RaceCheckPoint.cc	(revision 8821)
+++ code/branches/output/src/modules/gametypes/RaceCheckPoint.cc	(revision 8822)
@@ -29,13 +29,14 @@
 #include "RaceCheckPoint.h"
 
+#include "util/Convert.h"
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
+#include "network/Host.h"
 #include "SpaceRace.h"
-#include "util/Convert.h"
 
 namespace orxonox
 {
     CreateFactory(RaceCheckPoint);
-    
+
     RaceCheckPoint::RaceCheckPoint(BaseObject* creator): DistanceTrigger(creator), RadarViewable(creator, static_cast<WorldEntity*>(this))
     {
@@ -50,9 +51,9 @@
         this->setRadarVisibility(false);
     }
-    
+
     RaceCheckPoint::~RaceCheckPoint()
     {
     }
-    
+
     void RaceCheckPoint::tick(float dt)
     {
@@ -66,5 +67,5 @@
     }
 
-    
+
     void RaceCheckPoint::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
@@ -75,5 +76,5 @@
         XMLPortParam(RaceCheckPoint, "timelimit", setTimelimit, getTimeLimit, xmlelement, mode).defaultValues(0);
     }
-    
+
     void RaceCheckPoint::triggered(bool bIsTriggered)
     {
@@ -99,5 +100,5 @@
         }
     }
-    
+
     void RaceCheckPoint::setTimelimit(float timeLimit)
     {
@@ -110,9 +111,9 @@
                 const std::string& message =  "You have " + multi_cast<std::string>(this->bTimeLimit_)
                             + " seconds to reach the check point " + multi_cast<std::string>(this->bCheckpointIndex_+1);
-                orxout(level::message) << message << endl;
                 const_cast<GametypeInfo*>(gametype->getGametypeInfo())->sendAnnounceMessage(message);
+                Host::Broadcast(message);
             }
         }
     }
-    
+
 }
Index: code/branches/output/src/modules/gametypes/SpaceRace.cc
===================================================================
--- code/branches/output/src/modules/gametypes/SpaceRace.cc	(revision 8821)
+++ code/branches/output/src/modules/gametypes/SpaceRace.cc	(revision 8822)
@@ -38,5 +38,5 @@
 {
     CreateUnloadableFactory(SpaceRace);
-    
+
     SpaceRace::SpaceRace(BaseObject* creator) : Gametype(creator)
     {
@@ -46,9 +46,9 @@
         this->numberOfBots_ = 0;
     }
-    
+
     void SpaceRace::end()
     {
         this->Gametype::end();
-          
+
         if (this->bTimeIsUp_)
         {
@@ -59,5 +59,4 @@
                         + "You didn't reach the check point " + multi_cast<std::string>(this->bCheckpointsReached_+1)
                         + " before the time limit. You lose!";
-            orxout(level::message) << message << endl;
             const_cast<GametypeInfo*>(this->getGametypeInfo())->sendAnnounceMessage(message);
             Host::Broadcast(message);
@@ -70,12 +69,13 @@
             const std::string& message = "You win!! You have reached the last check point after "+ multi_cast<std::string>(s)
                         + "." + multi_cast<std::string>(ms) + " seconds.";
-            orxout(level::message) << message << endl;
             const_cast<GametypeInfo*>(this->getGametypeInfo())->sendAnnounceMessage(message);
             Host::Broadcast(message);
+/*
             float time = this->clock_.getSecondsPrecise();
             this->scores_.insert(time);
             std::set<float>::iterator it;
             for (it=this->scores_.begin(); it!=this->scores_.end(); it++)
-            orxout(level::message) << multi_cast<std::string>(*it) << endl;
+                orxout(level::message) << multi_cast<std::string>(*it) << endl;
+*/
         }
     }
@@ -86,8 +86,7 @@
 
         std::string message("The match has started! Reach the check points as quickly as possible!");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
-    
+
     void SpaceRace::newCheckpointReached()
     {
@@ -99,5 +98,4 @@
                         + " reached after " + multi_cast<std::string>(s) + "." + multi_cast<std::string>(ms)
                         + " seconds.";
-        orxout(level::message) << message << endl;
         const_cast<GametypeInfo*>(this->getGametypeInfo())->sendAnnounceMessage(message);
         Host::Broadcast(message);
Index: code/branches/output/src/modules/overlays/hud/ChatOverlay.cc
===================================================================
--- code/branches/output/src/modules/overlays/hud/ChatOverlay.cc	(revision 8821)
+++ code/branches/output/src/modules/overlays/hud/ChatOverlay.cc	(revision 8822)
@@ -87,5 +87,4 @@
 
         this->messages_.push_back(multi_cast<Ogre::DisplayString>(text));
-        orxout(level::message) << "Chat: " << text << endl;
 
         Timer* timer = new Timer();
Index: code/branches/output/src/orxonox/gametypes/Asteroids.cc
===================================================================
--- code/branches/output/src/orxonox/gametypes/Asteroids.cc	(revision 8821)
+++ code/branches/output/src/orxonox/gametypes/Asteroids.cc	(revision 8822)
@@ -74,5 +74,4 @@
 
         std::string message("The match has started! Reach the first chekpoint within 15 seconds! But be aware, there may be pirates around...");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
 
@@ -84,5 +83,4 @@
 
         std::string message("The match has ended.");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
Index: code/branches/output/src/orxonox/gametypes/Deathmatch.cc
===================================================================
--- code/branches/output/src/orxonox/gametypes/Deathmatch.cc	(revision 8821)
+++ code/branches/output/src/orxonox/gametypes/Deathmatch.cc	(revision 8822)
@@ -48,5 +48,4 @@
 
         std::string message("The match has started!");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
@@ -57,5 +56,4 @@
 
         std::string message("The match has ended.");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
@@ -66,5 +64,4 @@
 
         const std::string& message = player->getName() + " entered the game";
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
@@ -77,5 +74,4 @@
         {
             const std::string& message = player->getName() + " left the game";
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
@@ -91,5 +87,4 @@
         {
             const std::string& message = player->getOldName() + " changed name to " + player->getName();
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
@@ -113,5 +108,4 @@
                 message = victim->getPlayer()->getName() + " died";
 
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
@@ -127,5 +121,4 @@
         {
             const std::string& message = player->getName() + " scores!";
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
Index: code/branches/output/src/orxonox/gametypes/Dynamicmatch.cc
===================================================================
--- code/branches/output/src/orxonox/gametypes/Dynamicmatch.cc	(revision 8821)
+++ code/branches/output/src/orxonox/gametypes/Dynamicmatch.cc	(revision 8822)
@@ -343,5 +343,4 @@
         Gametype::playerEntered(player);
         const std::string& message = player->getName() + " entered the game";
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
@@ -359,5 +358,4 @@
             }
             const std::string& message = player->getName() + " left the game";
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
             //remove player from map
@@ -617,5 +615,4 @@
         {
             const std::string& message = player->getOldName() + " changed name to " + player->getName();
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
@@ -630,5 +627,4 @@
         {
             std::string message("Dynamicmatch started!");
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
@@ -647,5 +643,4 @@
     {
         std::string message("Earn points:\n\n\n\tIf you're red: Chase the blue player!\n\n\tIf you're blue shoot at a red player or hide.\n\n\tIf you're green: You've got the licence to kill red players!");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
         callInstructions_.setTimer(10, false, createExecutor(createFunctor(&Dynamicmatch::furtherInstructions, this)));
@@ -655,5 +650,4 @@
     {
         std::string message("After 3 Minutes the game is over.");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }*/
@@ -663,5 +657,4 @@
 
         std::string message("Time out. Press F2 to see the points you scored.");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
     }
Index: code/branches/output/src/orxonox/gametypes/LastManStanding.cc
===================================================================
--- code/branches/output/src/orxonox/gametypes/LastManStanding.cc	(revision 8821)
+++ code/branches/output/src/orxonox/gametypes/LastManStanding.cc	(revision 8822)
@@ -90,5 +90,5 @@
                 const std::string& message = ""; // resets Camper-Warning-message
                 this->gtinfo_->sendFadingMessage(message,it->first->getClientID());
-            }    
+            }
         }
         return true;
@@ -105,5 +105,4 @@
             this->playersAlive--;
             const std::string& message = victim->getPlayer()->getName() + " has lost all lives";
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
@@ -128,5 +127,5 @@
     {
         Gametype::end();
-        
+
         for (std::map<PlayerInfo*, int>::iterator it = this->playerLives_.begin(); it != this->playerLives_.end(); ++it)
         {
@@ -148,5 +147,5 @@
             return 0;
     }
-    
+
     int LastManStanding::getNumPlayersAlive() const
     {
@@ -190,5 +189,5 @@
         this->timeToAct_[player]=timeRemaining+3.0f+respawnDelay;//reset timer
         this->playerDelayTime_[player]=respawnDelay;
-        
+
         std::map<PlayerInfo*, Player>::iterator it = this->players_.find(player);
         if (it != this->players_.end())
@@ -198,5 +197,5 @@
             const std::string& message = ""; // resets Camper-Warning-message
             this->gtinfo_->sendFadingMessage(message,it->first->getClientID());
-        }  
+        }
     }
 
@@ -239,9 +238,9 @@
             }
             for (std::map<PlayerInfo*, float>::iterator it = this->timeToAct_.begin(); it != this->timeToAct_.end(); ++it)
-            {   
+            {
                 if (playerGetLives(it->first)<=0)//Players without lives shouldn't be affected by time.
-                    continue;     
+                    continue;
                 it->second-=dt;//Decreases punishment time.
-                if (!inGame_[it->first])//Manages respawn delay - player is forced to respawn after the delaytime is used up. 
+                if (!inGame_[it->first])//Manages respawn delay - player is forced to respawn after the delaytime is used up.
                 {
                     playerDelayTime_[it->first]-=dt;
Index: code/branches/output/src/orxonox/gametypes/LastTeamStanding.cc
===================================================================
--- code/branches/output/src/orxonox/gametypes/LastTeamStanding.cc	(revision 8821)
+++ code/branches/output/src/orxonox/gametypes/LastTeamStanding.cc	(revision 8822)
@@ -119,5 +119,4 @@
                 this->teamsAlive--;
             const std::string& message = victim->getPlayer()->getName() + " has lost all lives";
-            orxout(level::message) << message << endl;
             Host::Broadcast(message);
         }
Index: code/branches/output/src/orxonox/gametypes/UnderAttack.cc
===================================================================
--- code/branches/output/src/orxonox/gametypes/UnderAttack.cc	(revision 8821)
+++ code/branches/output/src/orxonox/gametypes/UnderAttack.cc	(revision 8822)
@@ -70,5 +70,4 @@
         this->end(); //end gametype
         std::string message("Ship destroyed! Team 0 has won!");
-        orxout(level::message) << message << endl;
         Host::Broadcast(message);
         this->gameEnded_ = true;
@@ -153,5 +152,4 @@
                 this->end();
                 std::string message("Time is up! Team 1 has won!");
-                orxout(level::message) << message << endl;
                 Host::Broadcast(message);
 
@@ -173,5 +171,4 @@
                 const std::string& message = multi_cast<std::string>(timesequence_) + " seconds left!";
 /*
-                orxout(level::message) << message << endl;
                 Host::Broadcast(message);
 */