Index: /code/branches/output/src/libraries/core/ConfigFileManager.cc
===================================================================
--- /code/branches/output/src/libraries/core/ConfigFileManager.cc	(revision 8830)
+++ /code/branches/output/src/libraries/core/ConfigFileManager.cc	(revision 8831)
@@ -123,10 +123,7 @@
         for (std::list<ConfigFileEntry*>::const_iterator it = this->entries_.begin(); it != this->entries_.end(); ++it)
             if ((*it)->getName() == name)
-                if ((*it)->getIndex() > size)
-                    size = (*it)->getIndex();
-        if (size == 0)
-            return 0;
-        else
-            return (size + 1);
+                if ((*it)->getIndex() >= size)
+                    size = (*it)->getIndex() + 1;
+        return size;
     }
 
Index: /code/branches/output/src/libraries/core/command/Shell.cc
===================================================================
--- /code/branches/output/src/libraries/core/command/Shell.cc	(revision 8830)
+++ /code/branches/output/src/libraries/core/command/Shell.cc	(revision 8831)
@@ -135,5 +135,5 @@
                                this->configurableContexts_)
             .description("Additional output contexts shown in the " + this->getName())
-            .callback(static_cast<BaseWriter*>(this), &BaseWriter::changedConfigurableLevels);
+            .callback(static_cast<BaseWriter*>(this), &BaseWriter::changedConfigurableContexts);
     }
 
Index: /code/branches/output/src/libraries/util/output/BaseWriter.cc
===================================================================
--- /code/branches/output/src/libraries/util/output/BaseWriter.cc	(revision 8830)
+++ /code/branches/output/src/libraries/util/output/BaseWriter.cc	(revision 8831)
@@ -39,4 +39,6 @@
         this->configurableMaxLevel_ = level::none;
         this->configurableContextsMaxLevel_ = level::verbose;
+        this->configurableContexts_.push_back("example");
+        this->changedConfigurableLevels();
     }
 
Index: /code/branches/output/src/libraries/util/output/LogWriter.cc
===================================================================
--- /code/branches/output/src/libraries/util/output/LogWriter.cc	(revision 8830)
+++ /code/branches/output/src/libraries/util/output/LogWriter.cc	(revision 8831)
@@ -69,5 +69,5 @@
 
         if (this->bDefaultPath_)
-            OutputManager::getInstance().pushMessage(level::user_info, context::output(), "Opening log file " + name);
+            OutputManager::getInstance().pushMessage(level::user_info, context::undefined(), "Opening log file " + name);
 
         this->file_.open(name.c_str(), std::fstream::out);
@@ -76,5 +76,5 @@
             this->printLine("Log file opened", level::none);
         else
-            OutputManager::getInstance().pushMessage(level::user_warning, context::output(), "Failed to open log file. File logging disabled.");
+            OutputManager::getInstance().pushMessage(level::user_warning, context::undefined(), "Failed to open log file. File logging disabled.");
     }
 
@@ -90,5 +90,5 @@
     void LogWriter::setLogPath(const std::string& path)
     {
-        OutputManager::getInstance().pushMessage(level::internal_info, context::output(), "Migrating log file from " + this->path_ + "\nto " + path);
+        OutputManager::getInstance().pushMessage(level::internal_info, context::undefined(), "Migrating log file from " + this->path_ + "\nto " + path);
 
         this->closeFile();
Index: /code/branches/output/src/libraries/util/output/OutputDefinitions.h
===================================================================
--- /code/branches/output/src/libraries/util/output/OutputDefinitions.h	(revision 8830)
+++ /code/branches/output/src/libraries/util/output/OutputDefinitions.h	(revision 8831)
@@ -85,5 +85,4 @@
             REGISTER_OUTPUT_CONTEXT(super);
             REGISTER_OUTPUT_CONTEXT(language);
-            REGISTER_OUTPUT_CONTEXT(output);
             REGISTER_OUTPUT_CONTEXT(commands);
             REGISTER_OUTPUT_CONTEXT(executor);