Index: /code/branches/output/src/libraries/core/ClassFactory.h
===================================================================
--- /code/branches/output/src/libraries/core/ClassFactory.h	(revision 8834)
+++ /code/branches/output/src/libraries/core/ClassFactory.h	(revision 8835)
@@ -73,5 +73,5 @@
             ClassFactory(const std::string& name, bool bLoadable = true)
             {
-                orxout(verbose, context::identifier) << "Create entry for " << name << " in Factory." << endl;
+                orxout(verbose, context::misc::factory) << "Create entry for " << name << " in Factory." << endl;
                 ClassIdentifier<T>::getIdentifier(name)->addFactory(this);
                 ClassIdentifier<T>::getIdentifier()->setLoadable(bLoadable);
Index: /code/branches/output/src/libraries/core/command/Executor.cc
===================================================================
--- /code/branches/output/src/libraries/core/command/Executor.cc	(revision 8834)
+++ /code/branches/output/src/libraries/core/command/Executor.cc	(revision 8835)
@@ -108,5 +108,5 @@
         }
 
-        orxout(verbose, context::executor) << "Executor::parse: \"" << arguments.join(delimiter) << "\" -> " << argCount << " arguments: " << arg[0] << " / " << arg[1] << " / " << arg[2] << " / " << arg[3] << " / " << arg[4] << endl;
+        orxout(verbose, context::misc::executor) << "Executor::parse: \"" << arguments.join(delimiter) << "\" -> " << argCount << " arguments: " << arg[0] << " / " << arg[1] << " / " << arg[2] << " / " << arg[3] << " / " << arg[4] << endl;
 
         // execute the function with the evaluated arguments (the default values of the executor are also included in these arguments)
Index: /code/branches/output/src/libraries/util/output/OutputDefinitions.h
===================================================================
--- /code/branches/output/src/libraries/util/output/OutputDefinitions.h	(revision 8834)
+++ /code/branches/output/src/libraries/util/output/OutputDefinitions.h	(revision 8835)
@@ -100,5 +100,4 @@
             REGISTER_OUTPUT_CONTEXT(language);
             REGISTER_OUTPUT_CONTEXT(commands);
-            REGISTER_OUTPUT_CONTEXT(executor);
             REGISTER_OUTPUT_CONTEXT(input);
             REGISTER_OUTPUT_CONTEXT(events);
@@ -120,47 +119,11 @@
             namespace misc
             {
-                REGISTER_OUTPUT_SUBCONTEXT(misc, testcontext1);
-                REGISTER_OUTPUT_SUBCONTEXT(misc, testcontext2);
-                REGISTER_OUTPUT_SUBCONTEXT(misc, testcontext3);
-                REGISTER_OUTPUT_SUBCONTEXT(misc, testcontext4);
+                REGISTER_OUTPUT_SUBCONTEXT(misc, executor);
+                REGISTER_OUTPUT_SUBCONTEXT(misc, factory);
+                REGISTER_OUTPUT_SUBCONTEXT(misc, gui);
+                REGISTER_OUTPUT_SUBCONTEXT(misc, overlays);
+                REGISTER_OUTPUT_SUBCONTEXT(misc, script);
             }
 
-            REGISTER_OUTPUT_CONTEXT(c30);
-            REGISTER_OUTPUT_CONTEXT(c31);
-            REGISTER_OUTPUT_CONTEXT(c32);
-            REGISTER_OUTPUT_CONTEXT(c33);
-            REGISTER_OUTPUT_CONTEXT(c34);
-            REGISTER_OUTPUT_CONTEXT(c35);
-            REGISTER_OUTPUT_CONTEXT(c36);
-            REGISTER_OUTPUT_CONTEXT(c37);
-            REGISTER_OUTPUT_CONTEXT(c38);
-            REGISTER_OUTPUT_CONTEXT(c39);
-            REGISTER_OUTPUT_CONTEXT(c40);
-            REGISTER_OUTPUT_CONTEXT(c41);
-            REGISTER_OUTPUT_CONTEXT(c42);
-            REGISTER_OUTPUT_CONTEXT(c43);
-            REGISTER_OUTPUT_CONTEXT(c44);
-            REGISTER_OUTPUT_CONTEXT(c45);
-            REGISTER_OUTPUT_CONTEXT(c46);
-            REGISTER_OUTPUT_CONTEXT(c47);
-            REGISTER_OUTPUT_CONTEXT(c48);
-            REGISTER_OUTPUT_CONTEXT(c49);
-            REGISTER_OUTPUT_CONTEXT(c50);
-            REGISTER_OUTPUT_CONTEXT(c51);
-            REGISTER_OUTPUT_CONTEXT(c52);
-            REGISTER_OUTPUT_CONTEXT(c53);
-            REGISTER_OUTPUT_CONTEXT(c54);
-            REGISTER_OUTPUT_CONTEXT(c55);
-            REGISTER_OUTPUT_CONTEXT(c56);
-            REGISTER_OUTPUT_CONTEXT(c57);
-            REGISTER_OUTPUT_CONTEXT(c58);
-            REGISTER_OUTPUT_CONTEXT(c59);
-            REGISTER_OUTPUT_CONTEXT(c60);
-            REGISTER_OUTPUT_CONTEXT(c61);
-            REGISTER_OUTPUT_CONTEXT(c62);
-            REGISTER_OUTPUT_CONTEXT(c63);
-            REGISTER_OUTPUT_CONTEXT(c64);
-            REGISTER_OUTPUT_CONTEXT(c65);
-            REGISTER_OUTPUT_CONTEXT(c66);
         }
     }
Index: /code/branches/output/src/modules/objects/Script.cc
===================================================================
--- /code/branches/output/src/modules/objects/Script.cc	(revision 8834)
+++ /code/branches/output/src/modules/objects/Script.cc	(revision 8835)
@@ -137,5 +137,5 @@
             return false;
 
-        orxout(internal_info) << "Script (&" << this << ") triggered." << endl;
+        orxout(verbose, context::misc::script) << "Script (&" << this << ") triggered." << endl;
 
         PlayerTrigger* pTrigger = orxonox_cast<PlayerTrigger*>(trigger);
Index: /code/branches/output/src/modules/overlays/GUIOverlay.cc
===================================================================
--- /code/branches/output/src/modules/overlays/GUIOverlay.cc	(revision 8834)
+++ /code/branches/output/src/modules/overlays/GUIOverlay.cc	(revision 8835)
@@ -76,10 +76,10 @@
             GUIManager::getInstance().showGUIExtra(this->guiName_, str);
 
-            orxout(internal_info) << "Showing GUI " << this->guiName_ << endl;
+            orxout(verbose, context::misc::gui) << "Showing GUI " << this->guiName_ << endl;
         }
         else
         {
             GUIManager::hideGUI(this->guiName_);
-            orxout(internal_info) << "Hiding GUI " << this->guiName_ << endl;
+            orxout(verbose, context::misc::gui) << "Hiding GUI " << this->guiName_ << endl;
         }
     }
Index: /code/branches/output/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- /code/branches/output/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 8834)
+++ /code/branches/output/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 8835)
@@ -362,10 +362,10 @@
             {
                 overlay->hide();
-                orxout(internal_info) << "HIDE " << name << endl;
+                orxout(verbose, context::misc::overlays) << "HIDE " << name << endl;
             }
             else
             {
                 overlay->show();
-                orxout(internal_info) << "SHOW " << name << endl;
+                orxout(verbose, context::misc::overlays) << "SHOW " << name << endl;
             }
         }